// SPDX-License-Identifier: GPL-2.0 OR MIT
/*
 * Copyright (C) 2023 MediaTek Inc.
 * Author: Macpaul Lin <macpaul.lin@mediatek.com>
 */

/dts-v1/;

#include <config.h>
#include "mt8195.dtsi"

/ {
	model = "MediaTek Genio-1200 EVK";
	compatible = "mediatek,genio-1200-evk", "mediatek,mt8195";

	smbios {
		compatible = "u-boot,sysinfo-smbios";
		smbios {
				system {
						manufacturer = "MediaTek";
						product = "Genio 1200 EVK P1V2 (eMMC Boot)";
						version = "P1V2";
						sku = "mtk-g1200evk-p1v2";
						family = "MediaTek Genio";
				};
				baseboard {
						manufacturer = "MediaTek";
						product = "Genio 1200 EVK P1V2";
				};
				chassis {
						manufacturer = "MediaTek";
				};
		};
	};

	memory@40000000 {
		/* 8GB */
		device_type = "memory";
		reg = <0 0x40000000 2 0x00000000>;
	};

	firmware: firmware {
		optee {
			compatible = "linaro,optee-tz";
			method = "smc";
		};

		psci: psci {
			compatible = "arm,psci-1.0";
			method = "smc";
		};
	};

	reserved-memory {
		#address-cells = <2>;
		#size-cells = <2>;
		ranges;

		/* 2 MiB reserved for ARM Trusted Firmware (BL31) */
		bl31_secmon_reserved: secmon@54600000 {
			no-map;
			reg = <0 0x54600000 0x0 0x200000>;
		};

		/* 12 MiB reserved for OP-TEE (BL32)
		 * +-----------------------+ 0x43e0_0000
		 * |      SHMEM 2MiB       |
		 * +-----------------------+ 0x43c0_0000
		 * |        | TA_RAM  8MiB |
		 * + TZDRAM +--------------+ 0x4340_0000
		 * |        | TEE_RAM 2MiB |
		 * +-----------------------+ 0x4320_0000
		 */
		optee_reserved: optee@43200000 {
			no-map;
			reg = <0 0x43200000 0 0x00c00000>;
		};

		dsi_reserved: dsi@60000000 {
			reg = <0 0x60000000 0 0x02000000>;
			no-map;
		};
	};

	chosen {
		stdout-path = &uart0;
	};

	reg_1p8v: regulator-1p8v {
		compatible = "regulator-fixed";
		regulator-name = "fixed-1.8V";
		regulator-min-microvolt = <1800000>;
		regulator-max-microvolt = <1800000>;
		regulator-boot-on;
		regulator-always-on;
	};

	reg_3p3v: regulator-3p3v {
		compatible = "regulator-fixed";
		regulator-name = "fixed-3.3V";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		regulator-boot-on;
		regulator-always-on;
	};

	dsi0: dsi0{
		compatible = "mediatek,mt8195-dsi";
		reg = <0 0x60000000 0 0x02000000>;
		pinctrl-names = "default";
		pinctrl-0 = <&panel_pins_default>;
		reset-gpios = <&gpio 108 GPIO_ACTIVE_HIGH>;
		dcdc-gpios = <&gpio 48 GPIO_ACTIVE_HIGH>;
		enable-gpios = <&gpio 47 GPIO_ACTIVE_HIGH>;
		clocks = <&topckgen CLK_TOP_DISP_PWM0>,
			<&infracfg_ao CLK_INFRA_AO_DISP_PWM>;
		clock-names = "main", "mm";
		status = "okay";
	};

	edp_tx: edp-tx@1c500000 {
		compatible = "mediatek,mt8195-edp-tx";
		reg = <0 0x60000000 0 0x02000000>;
		pinctrl-names = "default";
		pinctrl-0 = <&edp_pin_default>;
		vcc-gpios = <&gpio 6 GPIO_ACTIVE_HIGH>;
		bl-en-gpios = <&gpio 95 GPIO_ACTIVE_HIGH>;
		bl-vcc-gpios = <&gpio 96 GPIO_ACTIVE_HIGH>;
		pwm-gpios = <&gpio 104 GPIO_ACTIVE_HIGH>;
		status = "disabled";
	};
};

&pio {
	i2c0_pins: i2c0 {
		pinmux = <PINMUX_GPIO8__FUNC_SDA0>,
			 <PINMUX_GPIO9__FUNC_SCL0>;
		input-enable;
		bias-pull-up;
	};

	i2c1_pins: i2c1 {
		pinmux = <PINMUX_GPIO10__FUNC_SDA1>,
			 <PINMUX_GPIO11__FUNC_SCL1>;
		input-enable;
		bias-pull-up;
	};

	i2c2_pins: i2c2 {
		pinmux = <PINMUX_GPIO12__FUNC_SDA2>,
			 <PINMUX_GPIO13__FUNC_SCL2>;
		input-enable;
		bias-pull-up;
	};

	i2c6_pins: i2c6 {
		pinmux = <PINMUX_GPIO25__FUNC_SDA6>,
			 <PINMUX_GPIO26__FUNC_SCL6>;
		input-enable;
		bias-pull-up;
	};

	ethdefault: ethdefault {
		txdpins {
			pinmux = <PINMUX_GPIO77__FUNC_GBE_TXD3>,
				 <PINMUX_GPIO78__FUNC_GBE_TXD2>,
				 <PINMUX_GPIO79__FUNC_GBE_TXD1>,
				 <PINMUX_GPIO80__FUNC_GBE_TXD0>;
			drive-strength = <MTK_DRIVE_8mA>;
		};
		ccpins {
			pinmux = <PINMUX_GPIO85__FUNC_GBE_TXC>,
				 <PINMUX_GPIO88__FUNC_GBE_TXEN>,
				 <PINMUX_GPIO87__FUNC_GBE_RXDV>,
				 <PINMUX_GPIO86__FUNC_GBE_RXC>;
			drive-strength = <MTK_DRIVE_8mA>;
		};
		rxdpins {
			pinmux = <PINMUX_GPIO81__FUNC_GBE_RXD3>,
				 <PINMUX_GPIO82__FUNC_GBE_RXD2>,
				 <PINMUX_GPIO83__FUNC_GBE_RXD1>,
				 <PINMUX_GPIO84__FUNC_GBE_RXD0>;
		};
		mdiopins {
			pinmux = <PINMUX_GPIO89__FUNC_GBE_MDC>,
				 <PINMUX_GPIO90__FUNC_GBE_MDIO>;
			input-enable;
		};
		powerpins {
			pinmux = <PINMUX_GPIO91__FUNC_GPIO91>,
				 <PINMUX_GPIO92__FUNC_GPIO92>;
			output-high;
		};
		phyresetpin {
			pinmux = <PINMUX_GPIO93__FUNC_GPIO93>;
		};
	};

	ethsleep: ethsleep {
		txdpins {
			pinmux = <PINMUX_GPIO77__FUNC_GPIO77>,
				 <PINMUX_GPIO78__FUNC_GPIO78>,
				 <PINMUX_GPIO79__FUNC_GPIO79>,
				 <PINMUX_GPIO80__FUNC_GPIO80>;
		};
		ccpins {
			pinmux = <PINMUX_GPIO85__FUNC_GPIO85>,
				 <PINMUX_GPIO88__FUNC_GPIO88>,
				 <PINMUX_GPIO87__FUNC_GPIO87>,
				 <PINMUX_GPIO86__FUNC_GPIO86>;
		};
		rxdpins {
			pinmux = <PINMUX_GPIO81__FUNC_GPIO81>,
				 <PINMUX_GPIO82__FUNC_GPIO82>,
				 <PINMUX_GPIO83__FUNC_GPIO83>,
				 <PINMUX_GPIO84__FUNC_GPIO84>;
		};
		mdiopins {
			pinmux = <PINMUX_GPIO89__FUNC_GPIO89>,
				 <PINMUX_GPIO90__FUNC_GPIO90>;
			input-disable;
			bias-disable;
		};
		powerpins {
			pinmux = <PINMUX_GPIO91__FUNC_GPIO91>,
				 <PINMUX_GPIO92__FUNC_GPIO92>;
			input-disable;
			bias-disable;
		};
		phyresetpin {
			pinmux = <PINMUX_GPIO93__FUNC_GPIO93>;
			input-disable;
			bias-disable;
		};
	};

	panel_pins_default: panel-pins-default {
		panel-dcdc {
			pinmux = <PINMUX_GPIO48__FUNC_GPIO48>;
			output-low;
		};

		panel-en {
			pinmux = <PINMUX_GPIO47__FUNC_GPIO47>;
			output-low;
		};

		panel-rst {
			pinmux = <PINMUX_GPIO108__FUNC_GPIO108>;
			output-high;
		};

		pins-bl {
			pinmux = <PINMUX_GPIO97__FUNC_DISP_PWM0>;
		};
	};

	edp_pin_default: edp-pin-default {
		edp-panel-vcc {
			pinmux = <PINMUX_GPIO6__FUNC_GPIO6>;
			output-low;
		};

		edp-panel-hpd {
			pinmux = <PINMUX_GPIO7__FUNC_EDP_TX_HPD>;
			bias-pull-up;
		};

		edp-panel-bl-en {
			pinmux = <PINMUX_GPIO95__FUNC_GPIO95>;
			output-low;
		};

		edp-panel-bl-vcc {
			pinmux = <PINMUX_GPIO96__FUNC_GPIO96>;
			output-low;
		};

		edp-panel-pwm {
			pinmux = <PINMUX_GPIO104__FUNC_DISP_PWM1>;
			output-low;
		};
	};

	mmc1_pins_default: mmc1default {
		pins-cmd-dat {
			pinmux = <PINMUX_GPIO110__FUNC_MSDC1_CMD>,
				 <PINMUX_GPIO112__FUNC_MSDC1_DAT0>,
				 <PINMUX_GPIO113__FUNC_MSDC1_DAT1>,
				 <PINMUX_GPIO114__FUNC_MSDC1_DAT2>,
				 <PINMUX_GPIO115__FUNC_MSDC1_DAT3>;
			input-enable;
			drive-strength = <MTK_DRIVE_8mA>;
			bias-pull-up = <MTK_PUPD_SET_R1R0_01>;
		};

		pins-clk {
			pinmux = <PINMUX_GPIO111__FUNC_MSDC1_CLK>;
			drive-strength = <MTK_DRIVE_8mA>;
			bias-pull-down = <MTK_PUPD_SET_R1R0_10>;
		};
	};
};

&watchdog {
	status = "okay";
};

&uart0 {
	status = "okay";
};

&mmc0 {
	bus-width = <8>;
	max-frequency = <200000000>;
	cap-mmc-highspeed;
	mmc-hs200-1_8v;
	mmc-hs400-1_8v;
	hs400-ds-delay = <0x14c11>;
	cap-mmc-hw-reset;
	vmmc-supply = <&reg_3p3v>;
	vqmmc-supply = <&reg_1p8v>;
	non-removable;
	status = "okay";
};

&mmc1 {
	pinctrl-names = "default";
	pinctrl-0 = <&mmc1_pins_default>;
	bus-width = <4>;
	max-frequency = <52000000>;
	cap-sd-highspeed;
	vmmc-supply = <&reg_3p3v>;
	vqmmc-supply = <&reg_3p3v>;
	non-removable;
	status = "okay";
};

&usb {
	status = "okay";
};

&ssusb {
	mediatek,force-vbus;
	maximum-speed = "high-speed";
	dr_mode = "peripheral";
	status = "okay";
};

&xhci0 {
	status = "okay";
};

&xhci1 {
	status = "okay";
};

&i2c0 {
	clock-frequency = <100000>;
	pinctrl-0 = <&i2c0_pins>;
	pinctrl-names = "default";
	status = "okay";
};

&i2c1 {
	clock-frequency = <100000>;
	pinctrl-0 = <&i2c1_pins>;
	pinctrl-names = "default";
	status = "okay";
};

&i2c2 {
	clock-frequency = <100000>;
	pinctrl-0 = <&i2c2_pins>;
	pinctrl-names = "default";
	status = "okay";
};

&i2c6 {
	clock-frequency = <100000>;
	pinctrl-0 = <&i2c6_pins>;
	pinctrl-names = "default";
	status = "okay";
};

&eth {
	phy-mode ="rgmii-rxid";
	phy-handle = <&ethphy0>;
	mediatek,tx-delay-ps = <2030>;
	pinctrl-names = "default", "sleep";
	pinctrl-0 = <&ethdefault>;
	pinctrl-1 = <&ethsleep>;
	status = "okay";

	mdio {
		compatible = "snps,dwmac-mdio";
		#address-cells = <1>;
		#size-cells = <0>;
		ethphy0: ethphy0@1 {
			compatible = "ethernet-phy-id001c.c916";
			reg = <0x1>;
		};
	};
};

&auxadc {
	status = "okay";
};
